<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Card Game</title>
</head>
<body>
    <div class="container">
        <h1><label style="font-size : 40px"><center>Card Score</center></label></h1>
        <hr width="360px">
        <hr width="380px">
        <hr width="400px">
        <hr width="380px">
        <hr width="360px">
        <center><a id="nScore" style="font-size: 30px;"></a></center>
    </div>
<script type="text/javascript">
	let nCardArray=[
	{
		"nLabel": "J",
     	"nValue": 10,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId": 0
    },
    {
     	"nLabel": "Q",
     	"nValue": 10,
     	"eSuit": "s",
     	"isJoker": false,
     	"nGroupId": 0
    },
    {
    	"nLabel": "K",
    	"nValue": 10,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId": 0
    },
    {
    	"nLabel": "J",
    	"nValue": 10,
    	"eSuit": "d",
    	"isJoker": false,
    	"nGroupId": 1
    },
    {
    	"nLabel": "Q",
    	"nValue": 10,
    	"eSuit": "h",
    	"isJoker": false,
    	"nGroupId": 1
    },
    {
    	"nLabel": "K",
    	"nValue": 10,
    	"eSuit": "d",
    	"isJoker": false,
    	"nGroupId": 1
    },
    {
    	"nLabel": "A",
    	"nValue": 10,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId": 2
    },
    {
    	"nLabel": 2,
    	"nValue": 2,
    	"eSuit": "s",
    	"isJoker": true,
    	"nGroupId": 2
    },
    {
    	"nLabel": 8,
    	"nValue": 8,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId" : 2
    },
    {
    	"nLabel": 9,
    	"nValue": 9,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId": 2
    },
    {
    	"nLabel": 5,
    	"nValue": 5,
    	"eSuit": "c",
    	"isJoker": false,
    	"nGroupId": 3
    },
    {
    	"nLabel": 6,
    	"nValue": 6,
    	"eSuit": "c",
    	"isJoker": false,
    	"nGroupId": 3
    },
    {
    	"nLabel":2,
    	"nValue": 2,
    	"eSuit": "d",
    	"isJoker": true,
    	"nGroupId": 4
    },
    {
    	"nLabel": 3,
    	"nValue": 3,
    	"eSuit": "d",
    	"isJoker": false,
    	"nGroupId": 4
    },
    {
    	"nLabel": 8,
    	"nValue": 8,
    	"eSuit": "d",
    	"isJoker":false,
    	"nGroupId": 4
    },
    {
    	"nLabel": 5,
    	"nValue": 5,
    	"eSuit": "h",
    	"isJoker": false,
    	"nGroupId":5
    },
    {
    	"nLabel": 6,
    	"nValue": 6,
    	"eSuit": "h",
    	"isJoker": false,
    	"nGroupId": 5
    },
    {
    	"nLabel": "K",
    	"nValue": 10,
    	"eSuit": "h",
    	"isJoker": false,
    	"nGroupId": 5
    },
    {
    	"nLabel": 6,
    	"nValue": 6,
    	"eSuit": "c",
    	"isJoker": false,
    	"nGroupId": 6
    },
    {
    	"nLabel": 8,
    	"nValue": 8,
    	"eSuit": "s",
    	"isJoker": false,
    	"nGroupId":6
    },
    {
        "nLabel": 7,
        "nValue": 7,
        "eSuit": "d",
        "isJoker": false,
        "nGroupId":6
    },
    {
        "nLabel": 10,
        "nValue": 10,
        "eSuit": "d",
        "isJoker": false,
        "nGroupId": 6
    }
	]

    function group(){
        let nTotalScore = "";
        let nGroupArray = [];


        for(var i=0; i<nCardArray.length; i++){
            for(var j=0; j<nCardArray.length; j++){
                if(nCardArray[j].nGroupId == i){
                    nGroupArray.push(nCardArray[j]);
                }
            }
            if(nGroupArray.length == 0)
                break;
            console.log(nGroupArray);
            nTotalScore += `Score of group ${i}:${nCountScore(nGroupArray)}<br>`;
            document.getElementById('nScore').innerHTML=`${nTotalScore}`;
            console.log(nTotalScore);
            nGroupArray = [];
        }
    }
    group();

    function nCountScore(array){
        let eSameSuit = true;
        let eSequence = true;
        let nTotalScore = 0;

        for(let i=0; i<array.length-1; i++){
            if (array[i].eSuit != array[i+1].eSuit){
                eSameSuit = false;
                break
            }
        }
        array.sort((a,b) => a.nValue - b.nValue);
        for(var i=0; i<array.length-1; i++){
            if(array[i].nValue+1 != array[i+1].nValue){
                eSequence = false
                break
            }
        }
        if (eSameSuit && eSequence) {
            return nTotalScore
        }

        for(var i=0; i<array.length; i++){
            let value = array[i].nValue;
            if (value>10 || value==1) {
                value = 10;
            }
            if (array[i].isJoker) {
                value = 0;
            }
            nTotalScore += value;
        }
        return nTotalScore
    }
</script>
</body>
</html>